on mouseUp
  
  l = clipGetFormats()
  if l.getPos(13) then l.deleteOne(13) -- CF_UNICODETEXT
  cnt = count(l)
  
  formats=[]
  data=[]
  offsets=[]
  
  tOffset=0
  repeat with f in l
    d=clipGetData(f)
    formats.add(f)
    data.add(d)
    offsets.add(tOffset)
    tOffset = tOffset + length(d)+1
  end repeat
  
  s = chr(80) & chr(195) -- ???
  put getBinStr (cnt, 2) after s
  
  repeat with i = 1 to cnt
    f = formats[i]
    
    --    FormatID Specifies the clipboard-format identifier of the clipboard data. This is 2-byte value. 
    --    LenData  Specifies the length, in bytes, of the clipboard data. This is a 4-byte value. 
    --    OffData  Specifies the offset, in bytes, of the clipboard-data block. The offset is from the beginning of the file. This is a 4-byte value. 
    --    Name     Identifies a 79-character array specifying the format name of a private clipboard format.
    
    --FormatID
    put getBinStr (f, 2) after s
    
    --LenData
    put getBinStr (length(data[i])+1, 4) after s
    
    --OffData
    put getBinStr (4 + cnt*89 + offsets[i], 4) after s
    
    --Name
    put str_pad (clipGetFormatName(f), 79, chr(0)) after s
    
  end repeat
  
  repeat with i = 1 to cnt
    put data[i]&chr(0) after s
  end repeat  
  
  fn = display_save("Save CLP file as...", "CLP files,*.clp", "data.clp")
  if fn<>"" then file_put_contents(fn, s)
  
end