on mouseUp
  f=sprite(2).pFormat
  if voidP(f) then return
  
  str = clipGetData(f)
  
  case (f) of
    1: -- CF_TEXT
      fn = display_save("Save ANSI Text file as...", "ANSI Text files,*.txt", "test.txt")
      
    7: -- CF_OEMTEXT
      fn = display_save("Save OEM Text file as...", "OEM Text files,*.txt", "test.txt")
      
    13: -- CF_UNICODETEXT
      delete the last char of str
      put chr(255)&chr(254) before str -- ADD BOM
      fn = display_save("Save Unicode Text file as...", "Unicode Text files,*.txt", "test.txt")
      
    12: -- CF_WAVE
      fn = display_save("Save WAV file as...", "WAV files,*.wav", "test.wav")
      
      --8, 17: -- CF_DIB, CF_DIBV5 --> SAVE AS BMP
      
    8, 2: -- CF_DIB, CF_BITMAP --> SAVE AS BMP
      str = getBmpFromDib(str)      
      fn = display_save("Save BMP file as...", "BMP files,*.bmp", "test.bmp")
      
    3: --CF_METAFILEPICT
      fn = display_save("Save WMF file as...", "WMF files,*.wmf", "test.wmf")
      
    14: --CF_ENHMETAFILE
      fn = display_save("Save EMF file as...", "EMF files,*.emf", "test.emf")
      
    otherwise:
      
      -- CUSTOM FORMATS
      fn=sprite(2).pFormatName
      case (fn) of
        "Rich Text Format": -- RTF
          if str.char[str.length-1]<>"}" then put "}" after str -- Dir RTF bug
          fn = display_save("Save RTF file as...", "RTF files,*.rtf", "test.rtf")
          
        "HTML Format": -- HTML
          htmlStart=offset("<HTML",str)
          str=str.char[htmlStart..str.length]
          fn = display_save("Save HTML file as...", "HTML files,*.htm", "test.htm")
          
        otherwise:
          fn = display_save("Save file as...", "data files,*.dat", "test.dat")
          
      end case
      
  end case
  
  if fn<>"" then
    file_put_contents(fn, str)
  end if
  
  --  1  CF_TEXT
  --  2  CF_BITMAP
  --  3  CF_METAFILEPICT
  --  4  CF_SYLK
  --  5  CF_DIF
  --  6  CF_TIFF
  --  7  CF_OEMTEXT
  --  8  CF_DIB
  --  9  CF_PALETTE
  --  10 CF_PENDATA
  --  11 CF_RIFF
  --  12 CF_WAVE
  --  13 CF_UNICODETEXT
  --  14 CF_ENHMETAFILE
  --  15 CF_HDROP
  --  16 CF_LOCALE
  --  17 CF_DIBV5
  --  18 CF_MAX
  
end